diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/test/channel-access-manager-test.cc ns-3.31/src/wifi/test/channel-access-manager-test.cc
--- ns-3.30.1/src/wifi/test/channel-access-manager-test.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/test/channel-access-manager-test.cc	2020-06-27 17:38:30.000000000 -0700
@@ -21,11 +21,12 @@
 #include "ns3/test.h"
 #include "ns3/simulator.h"
 #include "ns3/channel-access-manager.h"
-#include "ns3/txop.h"
+#include "ns3/qos-txop.h"
 #include "ns3/mac-low.h"
 
 using namespace ns3;
 
+template <typename TxopType>
 class ChannelAccessManagerTest;
 
 /**
@@ -34,16 +35,17 @@
  *
  * \brief TxopTest Txop Test
  */
-class TxopTest : public Txop
+template <typename TxopType>
+class TxopTest : public TxopType
 {
 public:
   /**
    * Constructor
    *
-   * \param test the test DCF manager
-   * \param i the DCF state
+   * \param test the test channel access manager
+   * \param i the index of the Txop
    */
-  TxopTest (ChannelAccessManagerTest *test, uint32_t i);
+  TxopTest (ChannelAccessManagerTest<TxopType> *test, uint32_t i);
 
   /**
    * Queue transmit function
@@ -54,34 +56,67 @@
 
 private:
   /// allow ChannelAccessManagerTest class access
-  friend class ChannelAccessManagerTest;
+  friend class ChannelAccessManagerTest<TxopType>;
+
+  /// Inherited
+  void DoDispose (void);
 
   typedef std::pair<uint64_t,uint64_t> ExpectedGrant; //!< the expected grant typedef
   typedef std::list<ExpectedGrant> ExpectedGrants; //!< the collection of expected grants typedef
-  /// ExpectedCollision structure
-  struct ExpectedCollision
+  /// ExpectedBackoff structure
+  struct ExpectedBackoff
   {
     uint64_t at; //!< at
     uint32_t nSlots; //!< number of slots
   };
-  typedef std::list<struct ExpectedCollision> ExpectedCollisions; //!< expected collisions typedef
+  typedef std::list<struct ExpectedBackoff> ExpectedBackoffs; //!< expected backoffs typedef
 
-  ExpectedCollisions m_expectedInternalCollision; //!< expected internal collisions
-  ExpectedCollisions m_expectedCollision; //!< expected collision
+  ExpectedBackoffs m_expectedInternalCollision; //!< expected backoff due to an internal collision
+  ExpectedBackoffs m_expectedBackoff; //!< expected backoff (not due to an internal collision)
   ExpectedGrants m_expectedGrants; //!< expected grants
 
+  /**
+   * \returns true if access has been requested for this function and
+   *          has not been granted already, false otherwise.
+   */
   bool IsAccessRequested (void) const;
+  /**
+   * Notify that access request has been received.
+   */
   void NotifyAccessRequested (void);
+  /**
+   * Notify the Txop that access has been granted.
+   */
   void NotifyAccessGranted (void);
+  /**
+   * Notify the Txop that internal collision has occurred.
+   */
   void NotifyInternalCollision (void);
-  void NotifyCollision (void);
+  /**
+   * Generate a new backoff now.
+   */
+  void GenerateBackoff (void);
+  /**
+   * Check if the Txop has frames to transmit.
+   * \return true if the Txop has frames to transmit.
+   */
+  bool HasFramesToTransmit (void);
+  /**
+   * When a channel switching occurs, enqueued packets are removed.
+   */
   void NotifyChannelSwitching (void);
+  /**
+   * When sleep operation occurs, if there is a pending packet transmission,
+   * it will be reinserted to the front of the queue.
+   */
   void NotifySleep (void);
+  /**
+   * When wake up operation occurs, channel access will be restarted.
+   */
   void NotifyWakeUp (void);
-  void DoDispose (void);
 
-  ChannelAccessManagerTest *m_test; //!< the test DCF manager
-  uint32_t m_i; //!< the DCF state
+  ChannelAccessManagerTest<TxopType> *m_test; //!< the test DCF/EDCA manager
+  uint32_t m_i; //!< the index of the Txop
   bool m_accessRequested; //!< true if access requested
 };
 
@@ -98,7 +133,10 @@
   {
   }
   /**
-   * This function indicates whether it is the CF period.
+   * This function indicates whether Simulator::Now is in the CF period.
+   *
+   * \return true if Simulator::Now is in CF period,
+   *         false otherwise
    */
   bool IsCfPeriod (void) const
   {
@@ -110,8 +148,9 @@
  * \ingroup wifi-test
  * \ingroup tests
  *
- * \brief Dcf Manager Test
+ * \brief Channel Access Manager Test
  */
+template <typename TxopType>
 class ChannelAccessManagerTest : public TestCase
 {
 public:
@@ -120,22 +159,22 @@
 
   /**
    * Notify access granted function
-   * \param i the DCF state
+   * \param i the index of the Txop
    */
   void NotifyAccessGranted (uint32_t i);
   /**
    * Notify internal collision function
-   * \param i the DCF state
+   * \param i the index of the Txop
    */
   void NotifyInternalCollision (uint32_t i);
   /**
-   * Notify collision function
-   * \param i the DCF state
+   * Generate backoff function
+   * \param i the index of the Txop
    */
-  void NotifyCollision (uint32_t i);
+  void GenerateBackoff (uint32_t i);
   /**
    * Notify channel switching function
-   * \param i the DCF state
+   * \param i the index of the Txop
    */
   void NotifyChannelSwitching (uint32_t i);
 
@@ -146,43 +185,61 @@
    * \param slotTime the slot time
    * \param sifs the SIFS
    * \param eifsNoDifsNoSifs the EIFS no DIFS no SIFS
-   * \param ackTimeoutValue the ack timeout value
+   * \param ackTimeoutValue the Ack timeout value
    */
   void StartTest (uint64_t slotTime, uint64_t sifs, uint64_t eifsNoDifsNoSifs, uint32_t ackTimeoutValue = 20);
   /**
-   * Add DCF state function
+   * Add Txop function
    * \param aifsn the AIFSN
    */
-  void AddDcfState (uint32_t aifsn);
+  void AddTxop (uint32_t aifsn);
   /// End test function
   void EndTest (void);
   /**
    * Expect internal collision function
-   * \param time the expectedtime
+   * \param time the expected time
    * \param nSlots the number of slots
    * \param from the expected from
    */
   void ExpectInternalCollision (uint64_t time, uint32_t nSlots, uint32_t from);
   /**
-   * Expect internal collision function
-   * \param time the expectedtime
+   * Expect generate backoff function
+   * \param time the expected time
    * \param nSlots the number of slots
    * \param from the expected from
    */
-  void ExpectCollision (uint64_t time, uint32_t nSlots, uint32_t from);
+  void ExpectBackoff (uint64_t time, uint32_t nSlots, uint32_t from);
+  /**
+   * Schedule a check that the channel access manager is busy or idle
+   * \param time the expected time
+   * \param busy whether the manager is expected to be busy
+   */
+  void ExpectBusy (uint64_t time, bool busy);
   /**
-   * Add expect collision function
-   * \param at
+   * Perform check that channel access manager is busy or idle
+   * \param busy whether expected state is busy
+   */
+  void DoCheckBusy (bool busy);
+  /**
+   * Add receive OK event function
+   * \param at the event time
    * \param duration the duration
    */
   void AddRxOkEvt (uint64_t at, uint64_t duration);
   /**
-   * Add receive error event function
+   * Add receive error event function for error at end of frame
    * \param at the event time
    * \param duration the duration
    */
   void AddRxErrorEvt (uint64_t at, uint64_t duration);
   /**
+   * Add receive error event function for error during frame
+   * \param at the event time
+   * \param duration the duration
+   * \param timeUntilError the time after event time to force the error
+   */
+  void AddRxErrorEvt (uint64_t at, uint64_t duration, uint64_t timeUntilError);
+  /**
    * Add receive inside SIFS event function
    * \param at the event time
    * \param duration the duration
@@ -207,7 +264,7 @@
    */
   void AddNavStart (uint64_t at, uint64_t duration);
   /**
-   * Add ack timeout reset function
+   * Add Ack timeout reset function
    * \param at the event time
    */
   void AddAckTimeoutReset (uint64_t at);
@@ -216,36 +273,36 @@
    * \param at the event time
    * \param txTime the transmit time
    * \param expectedGrantTime the expected grant time
-   * \param from
+   * \param from the index of the requesting Txop
    */
   void AddAccessRequest (uint64_t at, uint64_t txTime,
                          uint64_t expectedGrantTime, uint32_t from);
   /**
-   * Add access request with ack timeout
+   * Add access request with Ack timeout
    * \param at time to schedule DoAccessRequest event
-   * \param txTime DoAccessRequest txTime
-   * \param expectedGrantTime DoAccessRequest expectedGrantTime
-   * \param from DoAccessRequest TxopTest
+   * \param txTime the transmit time
+   * \param expectedGrantTime the expected grant time
+   * \param from the index of the requesting Txop
    */
   void AddAccessRequestWithAckTimeout (uint64_t at, uint64_t txTime,
                                        uint64_t expectedGrantTime, uint32_t from);
   /**
    * Add access request with successful ack
    * \param at time to schedule DoAccessRequest event
-   * \param txTime DoAccessRequest txTime
-   * \param expectedGrantTime DoAccessRequest expectedGrantTime
-   * \param ackDelay is delay of the ack after txEnd
-   * \param from DoAccessRequest TxopTest
+   * \param txTime the transmit time
+   * \param expectedGrantTime the expected grant time
+   * \param ackDelay the delay of the Ack after txEnd
+   * \param from the index of the requesting Txop
    */
   void AddAccessRequestWithSuccessfullAck (uint64_t at, uint64_t txTime,
                                            uint64_t expectedGrantTime, uint32_t ackDelay, uint32_t from);
   /**
-   * Add access request with successful ack
-   * \param txTime DoAccessRequest txTime
-   * \param expectedGrantTime DoAccessRequest expectedGrantTime
+   * Add access request with successful Ack
+   * \param txTime the transmit time
+   * \param expectedGrantTime the expected grant time
    * \param state TxopTest
    */
-  void DoAccessRequest (uint64_t txTime, uint64_t expectedGrantTime, Ptr<TxopTest> state);
+  void DoAccessRequest (uint64_t txTime, uint64_t expectedGrantTime, Ptr<TxopTest<TxopType>> state);
   /**
    * Add CCA busy event function
    * \param at the event time
@@ -265,90 +322,110 @@
    */
   void AddRxStartEvt (uint64_t at, uint64_t duration);
 
-  typedef std::vector<Ptr<TxopTest> > TxopTests; //!< the TXOP tests typedef
+  typedef std::vector<Ptr<TxopTest<TxopType>>> TxopTests; //!< the TXOP tests typedef
 
   Ptr<MacLowStub> m_low; //!< the MAC low stubbed
-  Ptr<ChannelAccessManager> m_ChannelAccessManager; //!< the DCF manager
-  TxopTests m_txop; //!< the TXOP
-  uint32_t m_ackTimeoutValue; //!< the ack timeout value
+  Ptr<ChannelAccessManager> m_ChannelAccessManager; //!< the channel access manager
+  TxopTests m_txop; //!< the vector of Txop test instances
+  uint32_t m_ackTimeoutValue; //!< the Ack timeout value
 };
 
+template <typename TxopType>
 void
-TxopTest::QueueTx (uint64_t txTime, uint64_t expectedGrantTime)
+TxopTest<TxopType>::QueueTx (uint64_t txTime, uint64_t expectedGrantTime)
 {
   m_expectedGrants.push_back (std::make_pair (txTime, expectedGrantTime));
 }
 
-TxopTest::TxopTest (ChannelAccessManagerTest *test, uint32_t i)
+template <typename TxopType>
+TxopTest<TxopType>::TxopTest (ChannelAccessManagerTest<TxopType> *test, uint32_t i)
   : m_test (test),
     m_i (i),
     m_accessRequested (false)
 {
 }
 
+template <typename TxopType>
 void
-TxopTest::DoDispose (void)
+TxopTest<TxopType>::DoDispose (void)
 {
   m_test = 0;
   Txop::DoDispose ();
 }
 
+template <typename TxopType>
 bool
-TxopTest::IsAccessRequested (void) const
+TxopTest<TxopType>::IsAccessRequested (void) const
 {
   return m_accessRequested;
 }
 
+template <typename TxopType>
 void
-TxopTest::NotifyAccessRequested (void)
+TxopTest<TxopType>::NotifyAccessRequested (void)
 {
   m_accessRequested = true;
 }
 
+template <typename TxopType>
 void
-TxopTest::NotifyAccessGranted (void)
+TxopTest<TxopType>::NotifyAccessGranted (void)
 {
   m_accessRequested = false;
   m_test->NotifyAccessGranted (m_i);
 }
 
+template <typename TxopType>
 void
-TxopTest::NotifyInternalCollision (void)
+TxopTest<TxopType>::NotifyInternalCollision (void)
 {
   m_test->NotifyInternalCollision (m_i);
 }
 
+template <typename TxopType>
 void
-TxopTest::NotifyCollision (void)
+TxopTest<TxopType>::GenerateBackoff (void)
+{
+  m_test->GenerateBackoff (m_i);
+}
+
+template <typename TxopType>
+bool
+TxopTest<TxopType>::HasFramesToTransmit (void)
 {
-  m_test->NotifyCollision (m_i);
+  return !m_expectedGrants.empty ();
 }
 
+template <typename TxopType>
 void
-TxopTest::NotifyChannelSwitching (void)
+TxopTest<TxopType>::NotifyChannelSwitching (void)
 {
   m_test->NotifyChannelSwitching (m_i);
 }
 
+template <typename TxopType>
 void
-TxopTest::NotifySleep (void)
+TxopTest<TxopType>::NotifySleep (void)
 {
 }
 
+template <typename TxopType>
 void
-TxopTest::NotifyWakeUp (void)
+TxopTest<TxopType>::NotifyWakeUp (void)
 {
 }
 
-ChannelAccessManagerTest::ChannelAccessManagerTest ()
+template <typename TxopType>
+ChannelAccessManagerTest<TxopType>::ChannelAccessManagerTest ()
   : TestCase ("ChannelAccessManager")
 {
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::NotifyAccessGranted (uint32_t i)
+ChannelAccessManagerTest<TxopType>::NotifyAccessGranted (uint32_t i)
 {
-  Ptr<TxopTest> state = m_txop[i];
+  Ptr<TxopTest<TxopType>> state = m_txop[i];
   NS_TEST_EXPECT_MSG_EQ (state->m_expectedGrants.empty (), false, "Have expected grants");
   if (!state->m_expectedGrants.empty ())
     {
@@ -360,46 +437,50 @@
     }
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::AddTxEvt (uint64_t at, uint64_t duration)
+ChannelAccessManagerTest<TxopType>::AddTxEvt (uint64_t at, uint64_t duration)
 {
   Simulator::Schedule (MicroSeconds (at) - Now (),
                        &ChannelAccessManager::NotifyTxStartNow, m_ChannelAccessManager,
                        MicroSeconds (duration));
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::NotifyInternalCollision (uint32_t i)
+ChannelAccessManagerTest<TxopType>::NotifyInternalCollision (uint32_t i)
 {
-  Ptr<TxopTest> state = m_txop[i];
+  Ptr<TxopTest<TxopType>> state = m_txop[i];
   NS_TEST_EXPECT_MSG_EQ (state->m_expectedInternalCollision.empty (), false, "Have expected internal collisions");
   if (!state->m_expectedInternalCollision.empty ())
     {
-      struct TxopTest::ExpectedCollision expected = state->m_expectedInternalCollision.front ();
+      struct TxopTest<TxopType>::ExpectedBackoff expected = state->m_expectedInternalCollision.front ();
       state->m_expectedInternalCollision.pop_front ();
       NS_TEST_EXPECT_MSG_EQ (Simulator::Now (), MicroSeconds (expected.at), "Expected internal collision time is now");
       state->StartBackoffNow (expected.nSlots);
     }
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::NotifyCollision (uint32_t i)
+ChannelAccessManagerTest<TxopType>::GenerateBackoff (uint32_t i)
 {
-  Ptr<TxopTest> state = m_txop[i];
-  NS_TEST_EXPECT_MSG_EQ (state->m_expectedCollision.empty (), false, "Have expected collisions");
-  if (!state->m_expectedCollision.empty ())
+  Ptr<TxopTest<TxopType>> state = m_txop[i];
+  NS_TEST_EXPECT_MSG_EQ (state->m_expectedBackoff.empty (), false, "Have expected backoffs");
+  if (!state->m_expectedBackoff.empty ())
     {
-      struct TxopTest::ExpectedCollision expected = state->m_expectedCollision.front ();
-      state->m_expectedCollision.pop_front ();
-      NS_TEST_EXPECT_MSG_EQ (Simulator::Now (), MicroSeconds (expected.at), "Expected collision is now");
+      struct TxopTest<TxopType>::ExpectedBackoff expected = state->m_expectedBackoff.front ();
+      state->m_expectedBackoff.pop_front ();
+      NS_TEST_EXPECT_MSG_EQ (Simulator::Now (), MicroSeconds (expected.at), "Expected backoff is now");
       state->StartBackoffNow (expected.nSlots);
     }
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::NotifyChannelSwitching (uint32_t i)
+ChannelAccessManagerTest<TxopType>::NotifyChannelSwitching (uint32_t i)
 {
-  Ptr<TxopTest> state = m_txop[i];
+  Ptr<TxopTest<TxopType>> state = m_txop[i];
   if (!state->m_expectedGrants.empty ())
     {
       std::pair<uint64_t, uint64_t> expected = state->m_expectedGrants.front ();
@@ -409,31 +490,51 @@
   state->m_accessRequested = false;
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::ExpectInternalCollision (uint64_t time, uint32_t nSlots, uint32_t from)
+ChannelAccessManagerTest<TxopType>::ExpectInternalCollision (uint64_t time, uint32_t nSlots, uint32_t from)
 {
-  Ptr<TxopTest> state = m_txop[from];
-  struct TxopTest::ExpectedCollision col;
+  Ptr<TxopTest<TxopType>> state = m_txop[from];
+  struct TxopTest<TxopType>::ExpectedBackoff col;
   col.at = time;
   col.nSlots = nSlots;
   state->m_expectedInternalCollision.push_back (col);
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::ExpectCollision (uint64_t time, uint32_t nSlots, uint32_t from)
+ChannelAccessManagerTest<TxopType>::ExpectBackoff (uint64_t time, uint32_t nSlots, uint32_t from)
 {
-  Ptr<TxopTest> state = m_txop[from];
-  struct TxopTest::ExpectedCollision col;
-  col.at = time;
-  col.nSlots = nSlots;
-  state->m_expectedCollision.push_back (col);
+  Ptr<TxopTest<TxopType>> state = m_txop[from];
+  struct TxopTest<TxopType>::ExpectedBackoff backoff;
+  backoff.at = time;
+  backoff.nSlots = nSlots;
+  state->m_expectedBackoff.push_back (backoff);
+}
+
+template <typename TxopType>
+void
+ChannelAccessManagerTest<TxopType>::ExpectBusy (uint64_t time, bool busy)
+{
+  Simulator::Schedule (MicroSeconds (time) - Now (),
+                       &ChannelAccessManagerTest::DoCheckBusy, this, busy);
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::StartTest (uint64_t slotTime, uint64_t sifs, uint64_t eifsNoDifsNoSifs, uint32_t ackTimeoutValue)
+ChannelAccessManagerTest<TxopType>::DoCheckBusy (bool busy)
+{
+  NS_TEST_EXPECT_MSG_EQ (m_ChannelAccessManager->IsBusy (), busy, "Incorrect busy/idle state");
+}
+
+template <typename TxopType>
+void
+ChannelAccessManagerTest<TxopType>::StartTest (uint64_t slotTime, uint64_t sifs, uint64_t eifsNoDifsNoSifs, uint32_t ackTimeoutValue)
 {
   m_ChannelAccessManager = CreateObject<ChannelAccessManager> ();
   m_low = CreateObject<MacLowStub> ();
+  m_low->SetSlotTime (MicroSeconds (slotTime));
+  m_low->SetSifs (MicroSeconds (sifs));
   m_ChannelAccessManager->SetupLow (m_low);
   m_ChannelAccessManager->SetSlot (MicroSeconds (slotTime));
   m_ChannelAccessManager->SetSifs (MicroSeconds (sifs));
@@ -441,45 +542,42 @@
   m_ackTimeoutValue = ackTimeoutValue;
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::AddDcfState (uint32_t aifsn)
+ChannelAccessManagerTest<TxopType>::AddTxop (uint32_t aifsn)
 {
-  Ptr<TxopTest> txop = CreateObject<TxopTest> (this, m_txop.size ());
+  Ptr<TxopTest<TxopType>> txop = CreateObject<TxopTest<TxopType>> (this, m_txop.size ());
   txop->SetAifsn (aifsn);
   m_txop.push_back (txop);
-  m_ChannelAccessManager->Add (txop);
+  txop->SetChannelAccessManager (m_ChannelAccessManager);
+  txop->SetMacLow (m_low);
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::EndTest (void)
+ChannelAccessManagerTest<TxopType>::EndTest (void)
 {
   Simulator::Run ();
   Simulator::Destroy ();
 
-  for (TxopTests::const_iterator i = m_txop.begin (); i != m_txop.end (); i++)
+  for (typename TxopTests::const_iterator i = m_txop.begin (); i != m_txop.end (); i++)
     {
-      Ptr<TxopTest> state = *i;
+      Ptr<TxopTest<TxopType>> state = *i;
       NS_TEST_EXPECT_MSG_EQ (state->m_expectedGrants.empty (), true, "Have no expected grants");
       NS_TEST_EXPECT_MSG_EQ (state->m_expectedInternalCollision.empty (), true, "Have no internal collisions");
-      NS_TEST_EXPECT_MSG_EQ (state->m_expectedCollision.empty (), true, "Have no expected collisions");
+      NS_TEST_EXPECT_MSG_EQ (state->m_expectedBackoff.empty (), true, "Have no expected backoffs");
+      state->Dispose ();
       state = 0;
     }
   m_txop.clear ();
 
-  for (TxopTests::const_iterator i = m_txop.begin (); i != m_txop.end (); i++)
-    {
-      Ptr<TxopTest> txop = *i;
-      txop->Dispose ();
-      txop = 0;
-    }
-  m_txop.clear ();
-
   m_ChannelAccessManager = 0;
   m_low = 0;
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::AddRxOkEvt (uint64_t at, uint64_t duration)
+ChannelAccessManagerTest<TxopType>::AddRxOkEvt (uint64_t at, uint64_t duration)
 {
   Simulator::Schedule (MicroSeconds (at) - Now (),
                        &ChannelAccessManager::NotifyRxStartNow, m_ChannelAccessManager,
@@ -488,16 +586,18 @@
                        &ChannelAccessManager::NotifyRxEndOkNow, m_ChannelAccessManager);
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::AddRxInsideSifsEvt (uint64_t at, uint64_t duration)
+ChannelAccessManagerTest<TxopType>::AddRxInsideSifsEvt (uint64_t at, uint64_t duration)
 {
   Simulator::Schedule (MicroSeconds (at) - Now (),
                        &ChannelAccessManager::NotifyRxStartNow, m_ChannelAccessManager,
                        MicroSeconds (duration));
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::AddRxErrorEvt (uint64_t at, uint64_t duration)
+ChannelAccessManagerTest<TxopType>::AddRxErrorEvt (uint64_t at, uint64_t duration)
 {
   Simulator::Schedule (MicroSeconds (at) - Now (),
                        &ChannelAccessManager::NotifyRxStartNow, m_ChannelAccessManager,
@@ -506,38 +606,55 @@
                        &ChannelAccessManager::NotifyRxEndErrorNow, m_ChannelAccessManager);
 }
 
+template <typename TxopType>
+void
+ChannelAccessManagerTest<TxopType>::AddRxErrorEvt (uint64_t at, uint64_t duration, uint64_t timeUntilError)
+{
+  Simulator::Schedule (MicroSeconds (at) - Now (),
+                       &ChannelAccessManager::NotifyRxStartNow, m_ChannelAccessManager,
+                       MicroSeconds (duration));
+  Simulator::Schedule (MicroSeconds (at + timeUntilError) - Now (),
+                       &ChannelAccessManager::NotifyRxEndErrorNow, m_ChannelAccessManager);
+}
+
+
+template <typename TxopType>
 void
-ChannelAccessManagerTest::AddNavReset (uint64_t at, uint64_t duration)
+ChannelAccessManagerTest<TxopType>::AddNavReset (uint64_t at, uint64_t duration)
 {
   Simulator::Schedule (MicroSeconds (at) - Now (),
                        &ChannelAccessManager::NotifyNavResetNow, m_ChannelAccessManager,
                        MicroSeconds (duration));
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::AddNavStart (uint64_t at, uint64_t duration)
+ChannelAccessManagerTest<TxopType>::AddNavStart (uint64_t at, uint64_t duration)
 {
   Simulator::Schedule (MicroSeconds (at) - Now (),
                        &ChannelAccessManager::NotifyNavStartNow, m_ChannelAccessManager,
                        MicroSeconds (duration));
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::AddAckTimeoutReset (uint64_t at)
+ChannelAccessManagerTest<TxopType>::AddAckTimeoutReset (uint64_t at)
 {
   Simulator::Schedule (MicroSeconds (at) - Now (),
                        &ChannelAccessManager::NotifyAckTimeoutResetNow, m_ChannelAccessManager);
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::AddAccessRequest (uint64_t at, uint64_t txTime,
+ChannelAccessManagerTest<TxopType>::AddAccessRequest (uint64_t at, uint64_t txTime,
                                             uint64_t expectedGrantTime, uint32_t from)
 {
   AddAccessRequestWithSuccessfullAck (at, txTime, expectedGrantTime, 0, from);
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::AddAccessRequestWithAckTimeout (uint64_t at, uint64_t txTime,
+ChannelAccessManagerTest<TxopType>::AddAccessRequestWithAckTimeout (uint64_t at, uint64_t txTime,
                                                           uint64_t expectedGrantTime, uint32_t from)
 {
   Simulator::Schedule (MicroSeconds (at) - Now (),
@@ -545,8 +662,9 @@
                        txTime, expectedGrantTime, m_txop[from]);
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::AddAccessRequestWithSuccessfullAck (uint64_t at, uint64_t txTime,
+ChannelAccessManagerTest<TxopType>::AddAccessRequestWithSuccessfullAck (uint64_t at, uint64_t txTime,
                                                               uint64_t expectedGrantTime, uint32_t ackDelay, uint32_t from)
 {
   NS_ASSERT (ackDelay < m_ackTimeoutValue);
@@ -556,74 +674,75 @@
   AddAckTimeoutReset (expectedGrantTime + txTime + ackDelay);
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::DoAccessRequest (uint64_t txTime, uint64_t expectedGrantTime, Ptr<TxopTest> state)
+ChannelAccessManagerTest<TxopType>::DoAccessRequest (uint64_t txTime, uint64_t expectedGrantTime,
+                                                     Ptr<TxopTest<TxopType>> state)
 {
+  if (m_ChannelAccessManager->NeedBackoffUponAccess (state))
+    {
+      state->GenerateBackoff ();
+    }
   state->QueueTx (txTime, expectedGrantTime);
   m_ChannelAccessManager->RequestAccess (state);
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::AddCcaBusyEvt (uint64_t at, uint64_t duration)
+ChannelAccessManagerTest<TxopType>::AddCcaBusyEvt (uint64_t at, uint64_t duration)
 {
   Simulator::Schedule (MicroSeconds (at) - Now (),
                        &ChannelAccessManager::NotifyMaybeCcaBusyStartNow, m_ChannelAccessManager,
                        MicroSeconds (duration));
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::AddSwitchingEvt (uint64_t at, uint64_t duration)
+ChannelAccessManagerTest<TxopType>::AddSwitchingEvt (uint64_t at, uint64_t duration)
 {
   Simulator::Schedule (MicroSeconds (at) - Now (),
                        &ChannelAccessManager::NotifySwitchingStartNow, m_ChannelAccessManager,
                        MicroSeconds (duration));
 }
 
+template <typename TxopType>
 void
-ChannelAccessManagerTest::AddRxStartEvt (uint64_t at, uint64_t duration)
+ChannelAccessManagerTest<TxopType>::AddRxStartEvt (uint64_t at, uint64_t duration)
 {
   Simulator::Schedule (MicroSeconds (at) - Now (),
                        &ChannelAccessManager::NotifyRxStartNow, m_ChannelAccessManager,
                        MicroSeconds (duration));
 }
 
+/*
+ * Specialization of DoRun () method for DCF
+ */
+template <>
 void
-ChannelAccessManagerTest::DoRun (void)
+ChannelAccessManagerTest<Txop>::DoRun (void)
 {
-  // Bug 2369 addresses this case
-  //  0      3       4    5      8       9  10   12
-  //  | sifs | aifsn | tx | sifs | aifsn |   | tx |
+  // DCF immediate access (no backoff)
+  //  1      4       5    6      8     11      12
+  //  | sifs | aifsn | tx | idle | sifs | aifsn | tx |
   //
   StartTest (1, 3, 10);
-  AddDcfState (1);
-  AddAccessRequest (1, 1, 4, 0);
-  // Generate backoff when the request is within SIFS
-  ExpectCollision (1, 0, 0); // 0 slots
-  AddAccessRequest (10, 2, 10, 0);
-  EndTest ();
-  // Bug 2369 addresses this case
-  //  0      3       5    6      9       11  12   13
-  //  | sifs | aifsn | tx | sifs | aifsn |   | tx |
-  //
-  StartTest (1, 3, 10);
-  AddDcfState (2);
-  AddAccessRequest (4, 1, 5, 0);
-  // Generate backoff when the request is within AIFSN
-  ExpectCollision (4, 0, 0); // 0 slots
-  AddAccessRequest (12, 2, 12, 0);
+  AddTxop (1);
+  AddAccessRequest (1, 1, 5, 0);
+  AddAccessRequest (8, 2, 12, 0);
   EndTest ();
   // Check that receiving inside SIFS shall be cancelled properly:
-  //  0      3       4    5      8     9     12       13 14
-  //  | sifs | aifsn | tx | sifs | ack | sifs | aifsn |  |tx |
+  //  1      4       5    6      9    10     14     17      18
+  //  | sifs | aifsn | tx | sifs | ack | idle | sifs | aifsn | tx |
+  //                        |
+  //                        7 start rx
   //
 
   StartTest (1, 3, 10);
-  AddDcfState (1);
-  AddAccessRequest (1, 1, 4, 0);
-  ExpectCollision (1, 0, 0);
-  AddRxInsideSifsEvt (6, 10);
-  AddTxEvt (8, 1);
-  AddAccessRequest (14, 2, 14, 0);
+  AddTxop (1);
+  AddAccessRequest (1, 1, 5, 0);
+  AddRxInsideSifsEvt (7, 10);
+  AddTxEvt (9, 1);
+  AddAccessRequest (14, 2, 18, 0);
   EndTest ();
   // The test below mainly intends to test the case where the medium
   // becomes busy in the middle of a backoff slot: the backoff counter
@@ -636,11 +755,11 @@
   //       30 request access. backoff slots: 4
 
   StartTest (4, 6, 10);
-  AddDcfState (1);
+  AddTxop (1);
   AddRxOkEvt (20, 40);
   AddRxOkEvt (80, 20);
   AddAccessRequest (30, 2, 118, 0);
-  ExpectCollision (30, 4, 0); //backoff: 4 slots
+  ExpectBackoff (30, 4, 0); //backoff: 4 slots
   EndTest ();
   // Test the case where the backoff slots is zero.
   //
@@ -650,10 +769,10 @@
   //       30 request access. backoff slots: 0
 
   StartTest (4, 6, 10);
-  AddDcfState (1);
+  AddTxop (1);
   AddRxOkEvt (20, 40);
   AddAccessRequest (30, 2, 70, 0);
-  ExpectCollision (30, 0, 0); // backoff: 0 slots
+  ExpectBackoff (30, 0, 0); // backoff: 0 slots
   EndTest ();
   // Test shows when two frames are received without interval between
   // them:
@@ -663,38 +782,33 @@
   //       30 request access. backoff slots: 0
 
   StartTest (4, 6, 10);
-  AddDcfState (1);
+  AddTxop (1);
   AddRxOkEvt (20, 40);
   AddRxOkEvt (60, 40);
   AddAccessRequest (30, 2, 110, 0);
-  ExpectCollision (30, 0, 0); //backoff: 0 slots
+  ExpectBackoff (30, 0, 0); //backoff: 0 slots
   EndTest ();
 
-  // Bug 2369.  Test case of requesting access within SIFS interval
+  // Requesting access within SIFS interval (DCF immediate access)
   //
-  //  20    60     66      70         74
-  //   | rx  | sifs | aifsn | backoff | tx |
-  //           |
-  //          62 request access.
+  //  20    60     62     68      72
+  //   | rx  | idle | sifs | aifsn | tx |
   //
   StartTest (4, 6, 10);
-  AddDcfState (1);
+  AddTxop (1);
   AddRxOkEvt (20, 40);
-  AddAccessRequest (62, 2, 74, 0);
-  ExpectCollision (62, 1, 0); //backoff: 1 slots
+  AddAccessRequest (62, 2, 72, 0);
   EndTest ();
 
-  // Bug 2369.  Test case of requesting access after DIFS (no backoff)
+  // Requesting access after DIFS (DCF immediate access)
   //
-  //  20    60     66      70
-  //   | rx  | sifs | aifsn | tx |
-  //                        |
-  //                       70 request access.
+  //   20   60     70     76      80
+  //   | rx  | idle | sifs | aifsn | tx |
   //
   StartTest (4, 6, 10);
-  AddDcfState (1);
+  AddTxop (1);
   AddRxOkEvt (20, 40);
-  AddAccessRequest (70, 2, 70, 0);
+  AddAccessRequest (70, 2, 80, 0);
   EndTest ();
 
   // Test an EIFS
@@ -704,10 +818,37 @@
   //        |      | <------eifs------>|
   //       30 request access. backoff slots: 4
   StartTest (4, 6, 10);
-  AddDcfState (1);
+  AddTxop (1);
   AddRxErrorEvt (20, 40);
   AddAccessRequest (30, 2, 102, 0);
-  ExpectCollision (30, 4, 0); //backoff: 4 slots
+  ExpectBackoff (30, 4, 0); //backoff: 4 slots
+  EndTest ();
+
+  // Test DCF immediate access after an EIFS (EIFS is greater)
+  //
+  //  20          60     66           76             86
+  //               | <----+-eifs------>|
+  //   |    rx     | sifs | acktxttime | sifs + aifsn | tx |
+  //                             | sifs + aifsn |
+  //             request access 70             80
+  StartTest (4, 6, 10);
+  AddTxop (1);
+  AddRxErrorEvt (20, 40);
+  AddAccessRequest (70, 2, 86, 0);
+  EndTest ();
+
+  // Test that channel stays busy for first frame's duration after Rx error
+  //
+  //  20          60
+  //   |    rx     |
+  //        |
+  //       40 force Rx error
+  StartTest (4, 6, 10);
+  AddTxop (1);
+  AddRxErrorEvt (20, 40, 20); // At time 20, start reception for 40, but force error 20 into frame
+  ExpectBusy (41, true); // channel should remain busy for remaining duration
+  ExpectBusy (59, true);
+  ExpectBusy (61, false);
   EndTest ();
 
   // Test an EIFS which is interrupted by a successful transmission.
